
/*********************************************************************/
/*                      Declarations de types.                       */
/*********************************************************************/

        typedef struct {
                       uchar plot;
                       uchar attr;
                       } point;

        typedef struct fenetre {
                        cnat xo;
                        cnat yo;
                        cnat dx;
                        cnat dy;
                        cnat res;
                        cnat handle;
               		} fenetre;


        typedef struct st_menu  {
                                char nb_options;
                                char titre[TTITRE];
                                char options[NB_MAX][TTITRE];
                                union   {
                                        cnat (*fonction)();
                                        struct st_menu *menu_appel;
                                        } choix[NB_MAX];
                                } tmenu;

        typedef struct st_config {

                                cnat nation;
                                cnat niaff;
                                cnat lam;
                                cnat grille;
				cnat affnomcon;
				cnat fibremoy;
				cnat stick_diagram;
                                uchar style;
                                char pat[20];
                                uchar reso;
                                uchar teinte[7];
                                uchar autom;
				uchar rlog;
                                } tconfig;


        struct st_bens {
                        cnat mode ;
                        cnat cle ;
                        cnat scale ;
                        unsigned char coul[30] ;
                       } bens ;

		typedef struct st_segment {
								lnat x,y,dx,dy;
								uchar layer;
								} segment;
        typedef struct st_motif   {
                                char name[16];
								lnat nbseg;
								segment tab_seg[8];
								lnat xbb,ybb,dxbb,dybb;
								lnat xab,yab,dxab,dyab;
                                } motif;
        typedef struct st_setup
                        {

                        char path[80];
			char pathfile[80];
			char pathcatal[80];
                        char capa_nom[TAILLE_CHAINE];
                        char fond_nom[TAILLE_CHAINE];
                        char mode;                      /* 0 = Micron .                                 */
                                                        /* 1 = Symbolique .                             */

                        struct st_config defconf;       /* Valeur par defaut de la configuration .      */

                        struct  {
                                cnat nb;                /* Nombre de niveaux a afficher .               */
                                char nom[16][16];        /* Noms des niveaux .                           */
                                uchar couleur[19];      /* Couleurs des niveaux .                       */
                                uchar super[16][2];    /* Table des superpositions de couleurs .       */
                                uchar maxniv;
                                lnat contact[16];       /* Table des contacts physiques entre niveaux . */
                                } niveau;
                        struct  {
                                char entdir[3];          /* Prefixe des noms d'entrees directes.         */
                                char sordir[3];          /* Prefixe des noms de sorties directes.        */
                                cnat nbservi;
                                char servi[16][6];      /* Table des noms de servitudes (sauf alims)    */
                                cnat nbalim;
                                char alim[16][6];       /* Table des noms d'alimentations .             */
                                } declar;
                        struct  {
                                char souris;            /* Type souris  : 0 = Pas de souris .           */
                                                        /*                1 = Souris parallele .        */
                                                        /*        2 = Souris serie .                    */

                                char traceur;           /* Type traceur : 0 = Pas de traceur .          */
                                                        /*        1 = Traceur BENSON .                  */
                                                        /*       ...= Autre .                           */
                                } periph;
                        struct  {
                                char routeur[20];       /* Nom du routeur .                             */
                                char compilateur[20];   /* Nom du compilateur de cellules.              */
                                char testeur[20];       /* Nom du testeur sur masques.                  */
                                char simulateur[20];    /* Nom du simulateur logique.                   */
                                } outils;
                        struct  {
				char sufflog[5];        /* suffixe des fichiers logiques.               */
				char suffphy[5];        /* suffixe des fichiers physiques .              */
                                char titre[80];
				char prefixe_flatten[10];
				char nom_du_catal[80];
				lnat taille_du_catal;
                                } syntaxe;
                        struct  {
                                cnat nbmotif;
                                motif tab_motif[16];
				lnat tab_layer[16][16];
                                } motifs;
			uchar up,down,right,left,c1,c2,c3;
			uchar rep;
			cnat moti;
			lnat ext[16]; /* extension longitudinale pour le symbolique */
			lnat wmin[16]; /* largeur minimal d'un segment */
			lnat version; /* version du setup */

                        } type_setup;


	typedef struct bbab
		{
			char * nom;
			lnat xbb,ybb,dxbb,dybb;
			lnat xab,yab,dxab,dyab;
		} type_bbab;



/*********************************************************************/
/*********************************************************************/
/*                      Variables globales.                          */
/*********************************************************************/

        lnat xmire;     /* Abscisse mire.                            */
        lnat ymire;     /* Ordonnee   " .                            */
        lnat xfen;      /* Abscisse fenetre d'affichage.             */
        lnat yfen;      /* Ordonnee    "          "    .             */

        uchar zoom;
        char fichier[TAILLE_CHAINE];/* Nom du fichier en traitement.            */
        desc *fbuf1;

        cnat reso[2][10];
	cnat texatt[2];

        lnat status;

	cnat dfonc;	
	cnat dmenu;
	cnat fmenu;

        char ch;        /* Dernier caractere saisi au clavier.       */
        char special;   /* Si special=VRAI, le caractere vient du    */
                        /* pave numerique, si special=FAUX le cara-  */
                        /* ctere vient du clavier.                   */
        fenetre graph,menu,info; /* Fenetres d'affichage.            */

        tmenu menus[NB_MENUS];   /* Menus.                           */
        tconfig *config,mconfig;         /* Configuration editeur.           */




        lnat nligne,colonne;
        lnat xo,yo,y0ecran;
	lnat gsourisdx, gsourisdy;
        static type_setup setupp;
        cnat *fpil,*fpil1,*fpil2;
        char *fbuf2;
        char **catal;
        cnat num_eq;
        type_setup *setup;
	type_bbab * cache_bbab;
	lnat lundo;
extern char * namealloc();
extern type_bbab * cherche_bbab();
/*********************************************************************/
